
#Include Once "windows.bi"
#Include "rsrc.bi"
''
#Include Once "win/commdlg.bi" ' za FileOpenDlg
#Include Once "win/commctrl.bi" ' za Ctrl

#Include Once "soundmodule.bi"
'Konstante
Const szNULL=!"\0"
Const szFilter	= "Music Files (*.wav, *.mp3,*.ogg)" & szNULL & "*.wav;*.mp3;*.ogg" & szNULL
'Promenljive
Dim Shared hInstance As HMODULE
Dim Shared  lpCurrentFile As ZString*260
Dim Shared vPos As long
Dim Shared bPos As long
'Deklaracije funkcija
Declare Function DlgProc(ByVal hWin As HWND, ByVal uMsg As UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
Declare Function OpenMusicFile(ByVal hWin As HWND) As String

	''Ulazna tacka
	hInstance=GetModuleHandle(NULL)
	InitCommonControls
	DialogBoxParam(hInstance, Cast(ZString Ptr,IDD_MAIN), NULL, @DlgProc, NULL)
	ExitProcess(0)
	End
	''Kraj

Function DlgProc(ByVal hWin As HWND,ByVal uMsg As UINT,ByVal wParam As WPARAM,ByVal lParam As LPARAM) As Integer
	Dim As Long id, Event, x, y
	Dim hBtn As HWND
	Dim rect As RECT
	
	
	Select Case uMsg
		Case WM_INITDIALOG 'Ova poruka se dobija kad window treba da se pojavi
			vPos = 60 ' Podesavamo osnovnu vrednost
			'Ovde
			Music.Initialize ' Bass inicijalizacija
			Music.SetVolume(vPos)  'Podesavamo jacinu
			SendDlgItemMessage(hWin,IDC_VOL,TBM_SETPOS,TRUE,vPos) ' Podesavamo scroll
			SetDlgItemInt(hWin,IDC_VOLVAL,vPos,FALSE) ' Upisujemo u TextBox
			Return FALSE 
			'
		Case WM_CLOSE
			Music.Shutdown
			EndDialog(hWin, 0)
			'
		Case WM_COMMAND
			Select Case wParam ' Meni ID-ovi
				Case IDM_OPEN
					lpCurrentFile = OpenMusicFile(hWin)
					SetDlgItemText(hWin,IDC_FILE,@lpCurrentFile)
					Music.StopFile() ' Da bi stopirali predhodni
					Music.LoadFile(lpCurrentFile)
					Return FALSE
				Case Else
					Select Case LoWord(wParam)
						Case IDC_PLAY
							'Ovde
							If Not lpCurrentFile = ""  Then 
					'		If Not Music.PlayFile() Then 
					'			Music.LoadFile(Music.lpFile)
								Music.PlayFile() 
					'		EndIf
							Else
							SendMessage(hWin,WM_COMMAND,IDM_OPEN,0)
							EndIf 
							Return false
						Case IDC_PAUSE
							'Ovde
							If Not lpCurrentFile = ""  Then Music.PauseFile()
							Return false
						Case IDC_STOP
							'Ovde
							If Not lpCurrentFile = ""  Then Music.StopFile()
							Return false
					End Select
					Return false
			End Select
		Case WM_SIZE
			
			Return  FALSE 
		Case WM_HSCROLL 'Volume Scroll Default Scroll Min je 0 a Max 100 ' Sro se poklapa sa default vrednostima u Bass.dll
			vPos = SendDlgItemMessage(hWin,IDC_VOL,TBM_GETPOS,0,0) ' Dobijamo vrednost
			'Ovde
			Music.SetVolume(vPos) 'Podesavamo jacinu
			SetDlgItemInt(hWin,IDC_VOLVAL,vPos,FALSE) ' Upisujemo u TextBox
			Return FALSE 	
		Case Else
			Return FALSE
			'
	End Select
	Return TRUE

End Function

Function OpenMusicFile(ByVal hWin As HWND) As String
	Dim ofn As OPENFILENAME
	Dim buff As ZString*260

	ofn.lStructSize=SizeOf(OPENFILENAME)
	ofn.hwndOwner=hWin
	ofn.hInstance=hInstance
	ofn.lpstrInitialDir=StrPtr("C:\")
	buff=String(260,0)
	ofn.lpstrFile=@buff
	ofn.nMaxFile=260
	ofn.lpstrFilter=StrPtr(szFilter)
	ofn.lpstrTitle=StrPtr("Open File")
	ofn.Flags=OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER
	If GetOpenFileName(@ofn) Then
		Return buff
	EndIf
	
End Function

